// SPDX-License-Identifier: Apache-2.0
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
import { CommandHandler } from "../../../../../core/decorator/CommandHandlerDecorator";
import { lazyInject } from "../../../../../core/decorator/LazyInjectDecorator";
import { SetInterestRateCommand, SetInterestRateCommandResponse } from "./SetInterestRateCommand";
import TransactionService from "../../../../service/transaction/TransactionService";
import ContractService from "../../../../service/contract/ContractService";
import { SetInterestRateCommandError } from "./error/SetInterestRateCommandError";
import ValidationService from "../../../../service/validation/ValidationService";
import BigDecimal from "../../../../../domain/context/shared/BigDecimal";
import { SecurityRole } from "../../../../../domain/context/security/SecurityRole";
import AccountService from "../../../../service/account/AccountService";
let SetInterestRateCommandHandler = class SetInterestRateCommandHandler {
    transactionService;
    contractService;
    validationService;
    accountService;
    constructor(transactionService, contractService, validationService, accountService) {
        this.transactionService = transactionService;
        this.contractService = contractService;
        this.validationService = validationService;
        this.accountService = accountService;
    }
    async execute(command) {
        try {
            const { securityId, maxRate, baseRate, minRate, startPeriod, startRate, missedPenalty, reportPeriod, rateDecimals, } = command;
            const handler = this.transactionService.getHandler();
            const account = this.accountService.getCurrentAccount();
            await this.validationService.checkPause(securityId);
            await this.validationService.checkRole(SecurityRole._INTEREST_RATE_MANAGER_ROLE, account.id.toString(), securityId);
            const securityEvmAddress = await this.contractService.getContractEvmAddress(securityId);
            const maxRateBd = BigDecimal.fromString(maxRate, rateDecimals);
            const baseRateBd = BigDecimal.fromString(baseRate, rateDecimals);
            const minRateBd = BigDecimal.fromString(minRate, rateDecimals);
            const startPeriodBd = BigDecimal.fromString(startPeriod);
            const startRateBd = BigDecimal.fromString(startRate, rateDecimals);
            const missedPenaltyBd = BigDecimal.fromString(missedPenalty, rateDecimals);
            const reportPeriodBd = BigDecimal.fromString(reportPeriod);
            const res = await handler.setInterestRate(securityEvmAddress, maxRateBd, baseRateBd, minRateBd, startPeriodBd, startRateBd, missedPenaltyBd, reportPeriodBd, rateDecimals, securityId);
            return Promise.resolve(new SetInterestRateCommandResponse(res.error === undefined, res.id));
        }
        catch (error) {
            throw new SetInterestRateCommandError(error instanceof Error ? error : new Error(String(error)));
        }
    }
};
SetInterestRateCommandHandler = __decorate([
    CommandHandler(SetInterestRateCommand),
    __param(0, lazyInject(TransactionService)),
    __param(1, lazyInject(ContractService)),
    __param(2, lazyInject(ValidationService)),
    __param(3, lazyInject(AccountService)),
    __metadata("design:paramtypes", [TransactionService,
        ContractService,
        ValidationService,
        AccountService])
], SetInterestRateCommandHandler);
export { SetInterestRateCommandHandler };
